﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using Infragistics.Windows.DataPresenter;

namespace PersonalisationInGrid
{
    /// <summary>
    /// Interaction logic for Page1.xaml
    /// </summary>
    public partial class Page1 : Page
    {
        XamDataGrid myGrid = new XamDataGrid();
        DataTable dt = new DataTable("Table"); 
        public Page1()
        {
            InitializeComponent();
            //this.myGrid.FieldSettings.CellVisibilityWhenGrouped = Visibility.Visible;
            this.myGrid.FieldSettings.DataValueChangedNotificationsActive = true;
            this.myGrid.FieldSettings.DataValueChangedScope = Infragistics.Windows.DataPresenter.DataValueChangedScope.AllAllocatedRecords;
            this.myGrid.DataValueChanged += new EventHandler<Infragistics.Windows.DataPresenter.Events.DataValueChangedEventArgs>(myGrid_DataValueChanged);
            dt.Columns.Add("Name", typeof(string));
            dt.Columns.Add("Salary", typeof(Decimal));
            dt.Columns.Add("Status", typeof(string));

            DataRow dr = dt.NewRow();
            dr["Name"] = "Ramesh";
            dr["Salary"] = 12500;
            dr["Status"] = "O";
            dt.Rows.Add(dr);
            dr = dt.NewRow();
            dr["Name"] = "Ganesh";
            dr["Salary"] = 25000;
            dr["Status"] = "C";
            dt.Rows.Add(dr);
            dr = dt.NewRow();
            dr["Name"] = "Lakshmi";
            dr["Salary"] = 27400;
            dr["Status"] = "C";
            dt.Rows.Add(dr);           
        }

        string pref = string.Empty;

        void myGrid_DataValueChanged(object sender, Infragistics.Windows.DataPresenter.Events.DataValueChangedEventArgs e)
        {
            if (e.CellValuePresenter != null)
            {
                e.CellValuePresenter.Style = this.Resources["UpdatedCell"] as Style;               
            }
        }

        private void btn1_Click(object sender, RoutedEventArgs e)
        {
            pref = this.myGrid.SaveCustomizations();
        }

        private void btn2_Click(object sender, RoutedEventArgs e)
        {
            this.myGrid.LoadCustomizations(this.pref);
        }

        private void btn3_Click(object sender, RoutedEventArgs e)
        {
            if(this.rootGrid.Children.Contains(this.myGrid))
                this.rootGrid.Children.Remove(this.myGrid);

            this.myGrid = new XamDataGrid();
            this.rootGrid.Children.Add(this.myGrid);
            this.myGrid.FieldLayoutSettings.AutoGenerateFields = false;

            FieldLayout fieldLayout = new FieldLayout();
            Field f1 = new Field("Name");
            Field f2 = new Field("Salary");
            Field f3 = new Field("Status");
            fieldLayout.Fields.Add(f1);
            fieldLayout.Fields.Add(f2);
            fieldLayout.Fields.Add(f3);
            this.myGrid.FieldLayouts.Add(fieldLayout);

            this.myGrid.DataSource = dt.DefaultView;
            this.myGrid.FieldSettings.AllowEdit = false;
            this.myGrid.RecordContainerGenerationMode = Infragistics.Windows.Controls.ItemContainerGenerationMode.Virtualize;
            Grid.SetRow(this.myGrid, 1);

            if(!String.IsNullOrEmpty(this.pref))
                this.myGrid.LoadCustomizations(this.pref);
        }




    }

    #region RowSelectorValue Class
    public class RowSelectorValueConverter : IValueConverter
    {
        int rowIndex = 0;

        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {

            DataRecord dataRecord = value as DataRecord;


            Image image1 = new Image();
            if (dataRecord != null)
            {
                if (dataRecord.Index == 0)
                {
                    rowIndex = rowIndex + 1;
                }

                if (dataRecord.Index > 0 || rowIndex > 0)
                {
                    string status = string.Empty;

                    DataRowView datarowView = (DataRowView)dataRecord.DataItem;
                    if (datarowView != null)
                    {
                        status = datarowView["Status"].ToString();


                        // TODO : Write logic for linked/referred icons in I6
                        if (status == "C")
                        {
                            image1.Source = new BitmapImage(new Uri(@"http://localhost/i6Dev/Images/" + "Green.PNG", UriKind.Absolute));
                            return image1.Source;
                        }
                        else
                        {

                            image1.Source = new BitmapImage(new Uri(@"http://localhost/i6Dev/Images/" + "Red.PNG", UriKind.Absolute));
                            return image1.Source;

                        }
                    }
                }

            }
            return "";
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return null;

        }

        #endregion
    }

    #endregion

}
